
set random {}
proc random {m {o 0}} { global random 
        set random [expr {$random * 23}]
        return [expr {$random % $m + $o}]
}
proc save_random {} {
    global random prev_random
    if {$random=={}} {set random [clock clicks]}
    set prev_random $random
}
proc finish_random {} { uplevel "#0" { set save_random $random } }

proc display_random {} {
    set r .random
    catch {destroy $r}

    toplevel $r
    wm title $r "Randomizer"
    wm protocol $r WM_DELETE_WINDOW [list $r.dismiss invoke]

    label $r.l1 -text "Current Game-ID:"
    entry $r.old -state disabled -textvar prev_random
    bind $r.old <Double-Button-1> {.random.old selection range 0 end; break}

    label $r.l2 -text "Next Game-ID:"
    entry $r.new -textvar random -bg white
    bind $r.new <x> {set random {}; break}
    bind $r.new <c> {set random $prev_random; break}
    bind $r.new <Return> [list $r.restart invoke]
    bind $r.new <Escape> [list $r.dismiss invoke]
    bind $r.new <Double-Button-1> {.random.new selection range 0 end; break}
    focus $r.new

    button $r.dismiss -command {set random $save_random; destroy .random} \
        -text "Cancel"
    button $r.restart -command {win_new_game; destroy .random} \
        -text "new Game"

    pack $r.l1 $r.old $r.l2 $r.new 
    pack $r.dismiss $r.restart -side left

    bind $r <2> {break}
    bind $r <3> {break}
}
