proc readimg {imgname varname} { upvar 1 $varname src
    foreach {w h chunks} $src { 
        image create photo $imgname -width $w -height $h
        foreach chunk $chunks {
            foreach {x y pix} $chunk {
                $imgname put $pix -to $x $y
            }
        }
    }
}
    
if 0 {
proc show {tclf} {
    source $tclf

    set pics {z1 z2 z3 z4 z5 z6 z7 z8 z9 sel p1 p2 p3 p4 p5 p6 p7 p8 p9}

    puts reading...
    foreach pic $pics {
        readimg $pic img$pic
    }
    puts done.
    foreach pic $pics {
        pack [button .b_$pic -image $pic -command exit] -side left
    }
}
show images.tcl
}
